#include "lcd.h"

#include <avr/io.h>
#include <util/delay.h>



void lcd_enab(void);



void lcd_enab(void) {
  PORTC |= 0x10;
  _delay_us(40);
  PORTC = 0x00;
}



void lcd_init(void) {
  // lcd init
  DDRC = 0xFF;
  PORTC = 0x00;


// 4bit
  PORTC |= 0x03;
  lcd_enab();
  PORTC |= 0x03;
  lcd_enab();
  PORTC |= 0x03;
  lcd_enab();
  PORTC |= 0x02;
  lcd_enab();

// konf
  PORTC |= 0x02;
  lcd_enab();
  PORTC |= 0x09;
  lcd_enab();

// bias
  PORTC |= 0x01; 
  lcd_enab();
  PORTC |= 0x05; 
  lcd_enab();

// contrast
  PORTC |= 0x07; 
  lcd_enab();
  PORTC |= 0x02; 
  lcd_enab();

// power control
  PORTC |= 0x05; 
  lcd_enab();
  PORTC |= 0x05; 
  lcd_enab();

// follower control
  PORTC |= 0x06; 
  lcd_enab();
  PORTC |= 0x0E; 
  lcd_enab();

// display on
  PORTC |= 0x00; 
  lcd_enab();
  PORTC |= 0x0F; 
  lcd_enab();

// clear display
  PORTC |= 0x00; 
  lcd_enab();
  PORTC |= 0x01; 
  lcd_enab();
  _delay_ms(2);

// lcd init end
}



void lcd_clear(void) {
  PORTC |= 0x00; 
  lcd_enab();
  PORTC |= 0x01; 
  lcd_enab();
  _delay_ms(2);
}



void lcd_goto_xy(uint8_t x, uint8_t y) {
  PORTC |= y | 0x08; 
  lcd_enab();
  PORTC |= x; 
  lcd_enab();  
}



void lcd_putc(char c) {
  PORTC |= ((c>>4) | 0x40); 
  lcd_enab();
  PORTC |= ((c&0x0F) | 0x40); 
  lcd_enab();
}



void lcd_write(const char *s) {
  while (*s) {
    lcd_putc(*s);
    s++;
  }
}

